package infomat.algorithms.matrix;

import infomat.algorithms.grouping.RandomClusterer;
import infomat.vectorspace.*;

/**
 * Matrix Random Splitter. Not redy. Not used.
 * Utilizes IMatrixSplitter.
 *      
 * @version          080304
 * @author           Magnus Rosell
 */
public class IMatrixRandomSplitter{
    
    RandomClusterer randClusterer = new RandomClusterer();
    IMatrixSplitter matrixSplitter = new IMatrixSplitter();

    /**
     * Splits along rows or columns. Constructs corresponding groups
     * along the other dimension.
     */
    public IMatrix[] splitAlongDimension(IMatrix matrix, 
					 boolean row, int numberOfGroups){

	IObjectSet ioset = matrix.getColumnIObjectSet();
	if(row)
	    ioset = matrix.getRowIObjectSet();

	randClusterer.setProperty("Number of clusters", numberOfGroups);
	IObjectGrouping ioging = randClusterer.cluster(matrix, ioset);

	return matrixSplitter.splitAccordingToGrouping(matrix, ioging);
    }


    /**
     * Both are hard splits.
     */
    public IMatrix[][] splitAlongBothDimensions(IMatrix matrix, int numberOfRowGroups, int numberOfColumnGroups){

	IObjectSet rowioset = matrix.getRowIObjectSet();
	randClusterer.setProperty("Number of clusters", numberOfRowGroups);
	IObjectGrouping rowGrouping = randClusterer.cluster(matrix, rowioset);

	IObjectSet colioset = matrix.getColumnIObjectSet();
	randClusterer.setProperty("Number of clusters", numberOfColumnGroups);
	IObjectGrouping colGrouping = randClusterer.cluster(matrix, colioset);

	return matrixSplitter.splitAccordingToTwoGroupingsAlongDifferentDimensions(matrix, rowGroupin, colGrouping);

    }




}
