package infomat.vectorspace;

import java.util.*;


/**
 * A label for any IObject. So far only used for cluster labels,
 * that is for IObjectGroup:s.
 * It extends IObjectGroup for flexibility reasons - an ILabel is 
 * a set of IObject:s.
 *
 * @version          080218
 * @author           Magnus Rosell
 */
public class ILabel extends IObjectGroup{
    
    private IObject io;

    public ILabel(IObject io){
	super("Label for "+ io.getString());
	this.io=io;
    } 

    
    public String getLabelString(){
	String label="";
	for(int i=0; i<ordered.size(); i++){
	    label += "("+ordered.elementAt(i).getString()+", "+objectOrderValueMap.get(ordered.elementAt(i))+")";
	    if(i<ordered.size()-1)
		label += ", ";
	}
	return label;
    }

}
