package infomat.vectorspace.weighting;

import infomat.vectorspace.*;

import mro.util.*;
import mro.util.properties.*;

import java.lang.Math.*;
import java.util.*;

/**
 * A class for weighting of a IMatrix.
 *
 * @version          080619
 * @author           Magnus Rosell
 */
public abstract class Weighter implements HasProperties{
    mro.util.properties.Properties properties;

    public Weighter(){
	this.properties = getDefaultProperties();
    }

    public Weighter(mro.util.properties.Properties properties){
	this.properties = properties;
    }



    /**
     * Weight the IMatrix (the whole matrix, 
     * which may be more than the current IObjectGroupings, the picture).
     */
    public abstract void weight(IMatrix matrix);

    /**
     * Returns a String that identifies the Weighter.
     */
    public abstract String getWeighterName();
    
}
