package mro.util.experimentation;

import mro.util.measures.*;
import mro.util.properties.*;

import java.util.Vector;
import java.util.HashMap;

/**
 * Class for storing result info for each directory.
 *
 * @version          080505
 * @author           Magnus Rosell
 */
public class ResultPool{

    private Vector<Result> resultVector = new Vector<Result>();

    private HashMap<String, Result> pathResultMap = 
	new HashMap<String, Result>();
	
    private HashMap<Result, String> resultPathMap = 
	new HashMap<Result, String>();

    public void addResult(String dir, Measures measures, PropertiesPool pp){
	Vector<Measure> vec = measures.getMeasureVector();
	    
	if(vec.size()==0)
	    measures=null;
	if(pp.size()==0)
	    pp=null;
	if(measures!=null || pp!=null){
	    Result result = new Result(dir, measures, pp, null, null);
	    resultVector.add(result);
	    pathResultMap.put(dir, result);
	    resultPathMap.put(result, dir);
	}
    }

    public Measures getMeasuresForPath(String pathName){
	Result result = pathResultMap.get(pathName);
	if(result==null)
	    return null;
	return result.measures;
    }

    public PropertiesPool getPropertiesPoolForPath(String pathName){
	Result result = pathResultMap.get(pathName);
	if(result==null)
	    return null;
	return result.pp;
    }

    public Result getResultForPath(String pathName){
	return pathResultMap.get(pathName);
    }

    public String getPathForResult(Result result){
	return resultPathMap.get(result);
    }

    public Vector<Result> getResultVector(){
	return resultVector;
    }

}

